//Sends repeated download instructions over an Ethernet cable to the waveform mirror board in
//order to read out every value from one of the memory blocks.
//Boston University Electronics Design Facility--Conor DuBois

#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char**argv)
{
   int sockfd, repetition, n, index;
   struct sockaddr_in servaddr, cliaddr;
   char packet[300];
   FILE * output;

   sockfd=socket(AF_INET,SOCK_DGRAM,0);
   output = fopen("values.dat", "w+");

   bzero(&servaddr,sizeof(servaddr));
   servaddr.sin_family = AF_INET;
   if (argc != 2)
      servaddr.sin_addr.s_addr=inet_addr("192.168.1.2");
   else
      servaddr.sin_addr.s_addr=inet_addr(argv[1]);
   servaddr.sin_port=htons(32000);

   *(unsigned int *)(&packet[0]) = htonl(0x00950000);
   *(unsigned int *)(&packet[4]) = htonl(0x00000000);
   sendto(sockfd,packet,8,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
   bzero(packet, 300);
   n=recvfrom(sockfd,packet,300,0,NULL,NULL);
   printf("Received %d bytes\n", n);

   *(unsigned int *)(&packet[0]) = htonl(0x00930002);
   *(unsigned int *)(&packet[4]) = htonl(0x00000000);
   packet[8] = 0x00;
   packet[9] = 0x01;
   sendto(sockfd,packet,10,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
   bzero(packet, 300);
   n=recvfrom(sockfd,packet,300,0,NULL,NULL);
   printf("Received %d bytes\n", n);

   for(repetition = 0; repetition < 130; repetition += 1)
   {
      *(unsigned int *)(&packet[0]) = htonl(0x00120000 + (repetition<<8));
      *(unsigned int *)(&packet[4]) = htonl(repetition*127);
      sendto(sockfd,packet,8,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
      bzero(packet, 300);
      n=recvfrom(sockfd,packet,300,0,NULL,NULL);
      printf("Received %d bytes\n", n);
      for(index = 8; index < n && index < 32776 - repetition*254; index += 2)
      {
         fprintf(output, "%X\n", ((0xFF00 & (packet[index]<<8)) | (packet[index + 1] & 0xFF)));
      }
   }

   fclose(output);
}
