//Sends repeated upload instructions over an Ethernet cable to the waveform mirror board in
//order to fill one of the memory blocks with a square wave.
//Boston University Electronics Design Facility--Conor DuBois

#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char**argv)
{
   int sockfd, repetition, n;
   struct sockaddr_in servaddr, cliaddr;
   char packet[300];
   char buffer[256];

   sockfd=socket(AF_INET,SOCK_DGRAM,0);

   bzero(&servaddr,sizeof(servaddr));
   servaddr.sin_family = AF_INET;
   if(argc == 2)
      servaddr.sin_addr.s_addr=inet_addr(argv[1]);
   else
      servaddr.sin_addr.s_addr=inet_addr("192.168.1.2");
   servaddr.sin_port=htons(32000);

   *(unsigned int *)(&packet[0]) = htonl(0x00930002);
   *(unsigned int *)(&packet[4]) = htonl(0x00000000);
   packet[8] = 0x00;
   packet[9] = 0x00;
   sendto(sockfd,packet,10,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
   bzero(packet, 300);
   n=recvfrom(sockfd,packet,300,0,NULL,NULL);
   printf("Received %d bytes\n", n);

   for(repetition = 0; fgets(buffer, 255, stdin) != NULL; repetition += 2)
   {
      if(repetition % 254 == 0)
      {
         *(unsigned int *)(&packet[0]) = htonl(0x009400FE + ((repetition/254)<<8));
         *(unsigned int *)(&packet[4]) = htonl(repetition >> 1);
      }
      sscanf(buffer, "%d", &n);
      *(unsigned short *)(&packet[(repetition%254)+8]) = htons(n);
      if(repetition % 254 == 252)
      {
         sendto(sockfd,packet,262,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
         bzero(packet, 300);
         n=recvfrom(sockfd,packet,300,0,NULL,NULL);
         printf("Received %d bytes\n", n);
      }
   }
   *(unsigned int *)(&packet[0]) = htonl(0x00940000 + ((repetition/254)<<8) + (repetition%254));
   sendto(sockfd,packet,8+(repetition%254),0,(struct sockaddr *)&servaddr,sizeof(servaddr));
   bzero(packet, 300);
   n=recvfrom(sockfd,packet,300,0,NULL,NULL);
   printf("Received %d bytes\n", n);

   *(unsigned int *)(&packet[0]) = htonl(0x00950000);
   *(unsigned int *)(&packet[4]) = htonl(0x00000000);
   sendto(sockfd,packet,8,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
   bzero(packet, 300);
   n=recvfrom(sockfd,packet,300,0,NULL,NULL);
   printf("Received %d bytes\n", n);
}
